variables:
  GIT_SUBMODULE_STRATEGY: recursive
  STACKNAME: CICD_reporef$CI_COMMIT_REF_NAME
  NECTAR_ALLOCATION: HPCCICD
  ANSIBLE_HOST_KEY_CHECKING: "False"

stages:
#  - integration_test_downstream # working but unwanted here
#  - trigger_pipeline_in_B   # working but unwanted here
  - lint
  - delete_stack
  - extended
  - heat
  - ansible_create_cluster_stage
  - push_button_spawn_cluster
#  - e2e
  - tests
  - clean # manually delete stack


  
#trigger_pipeline_in_B:
#  stage: integration_test_downstream
#  tags: 
#  - ansible
#  script:
#  - "curl --request POST --form token=${CI_JOB_TOKEN} --form ref=master https://gitlab.erc.monash.edu.au/api/v4/projects/1085/trigger/pipeline"  # ID is from pysshauthz

heat_test:
  stage: heat
  allow_failure: false
  tags:
  - heat
  before_script:
    - source ./$NECTAR_ALLOCATION-openrc.sh
    - export HEAT_TEST_STACKNAME=_TESTING_HEAT
    - bash -x ./heat/heatcicdwrapper.sh delete_if_exists $HEAT_TEST_STACKNAME
    - sleep 60
  script:
    - echo "heat_test stage"
    - source ./$NECTAR_ALLOCATION-openrc.sh
    - bash -x ./heat/heatcicdwrapper.sh create $HEAT_TEST_STACKNAME
    - openstack stack list
    - bash -x ./heat/heatcicdwrapper.sh update $HEAT_TEST_STACKNAME
    - openstack stack list
    - bash -x ./heat/heatcicdwrapper.sh delete_if_exists $HEAT_TEST_STACKNAME
    - openstack stack list
  after_script:
    - sleep 20 # artifically wait a bit to make sure it is really dead
  when: manual

yamllint:
  stage: lint
  allow_failure: true
  tags: 
  - yamllint
  script:
    - echo "stage yamllint"
    - cd CICD
    # - ansible-lint -c .yamllintconf.yaml -x ANSIBLE0002 master_playbook.yml
    - yamllint -c ./.yamllintheat.yaml ./heat

delete_stack_manual:
  stage: delete_stack
  tags:
  - heat
  before_script:
    - echo "$GC_KEY" > gc_key.pem
    - chmod 400 gc_key.pem
    - echo "$HPCCICD_openrc" > ./$NECTAR_ALLOCATION-openrc.sh
  script:
    - echo "heat stage"
    - source ./$NECTAR_ALLOCATION-openrc.sh
    - openstack stack list
    - bash -x ./CICD/heat/heatcicdwrapper.sh delete_if_exists $STACKNAME
  when: manual

ansiblelint:
  allow_failure: true
  stage: lint
  tags: 
  - ansiblelint
  script:
    - echo "stage ansiblelint"
    - cd CICD
    - python3 ansiblelint/run_lint.py --targets master_playbook.yml
    

build_cluster_cicd:
  stage: heat
  allow_failure: false
  tags:
  - heat
  before_script:
    - echo "$GC_KEY" > gc_key.pem
    - chmod 400 gc_key.pem
    - echo "$HPCCICD_openrc" > ./$NECTAR_ALLOCATION-openrc.sh
  script:
    - echo "heat stage"
    - source ./$NECTAR_ALLOCATION-openrc.sh
    - openstack stack list
    - bash -x ./CICD/heat/heatcicdwrapper.sh create_or_update $STACKNAME
  after_script:
    - sleep 20 # artifically wait a bit to give the nodes time to boot
#  only:
#    changes: #https://docs.gitlab.com/ee/ci/yaml/#onlychangesexceptchanges
#    - "heat/*HOT*.yaml"
#    - schedules
#    - ./.gitlab-ci.yml

ansible_create_cluster_stage:
  stage: ansible_create_cluster_stage
  tags: 
  - ansible
  before_script:
    - echo "$GC_KEY" > gc_key.pem
    - chmod 400 gc_key.pem
    - echo "$HPCCICD_openrc" > ./$NECTAR_ALLOCATION-openrc.sh
  script:
    - echo "ansible_create_cluster_stage"
    - bash -x ./CICD/ansible_create_cluster_script.sh
  #after_script:
    #- rm ./files/inventory.$STACKNAME
  #only:
  #  changes: #https://docs.gitlab.com/ee/ci/yaml/#onlychangesexceptchanges
  #  - "master_playbook.yml"
  #  - "vars/*.{yml,yaml}"
  #  - schedules
  #  - CICD/.gitlab-ci.yml

tests:
  stage: tests
  tags:
  - ansible
  before_script:
    - echo "$GC_KEY" > gc_key.pem
    - chmod 400 gc_key.pem
    - echo "$HPCCICD_openrc" > ./$NECTAR_ALLOCATION-openrc.sh
  script:
    - echo "tests stage"
    - source ./$NECTAR_ALLOCATION-openrc.sh
    - openstack stack list
    - cd CICD
    - python3 ../scripts/make_inventory.py static $STACKNAME | tee ./files/inventory.$STACKNAME && chmod 755 ./files/inventory.$STACKNAME
    - grep -qv "I could not find any resouces tagged with project_name:" ./files/inventory.$STACKNAME   #fail if inventory file is empty
    - ansible -m ping -i files/inventory.$STACKNAME --key-file ../gc_key.pem all
    - ansible -i files/inventory.$STACKNAME --key-file ../gc_key.pem -a "sudo ls" all
    
    - ansible -B 30 -i files/inventory.$STACKNAME --key-file ../gc_key.pem -a "sinfo" ManagementNodes
    - ansible -B 30 -i files/inventory.$STACKNAME --key-file ../gc_key.pem -a "squeue" ManagementNodes
    - ansible -B 30 -i files/inventory.$STACKNAME --key-file ../gc_key.pem -a "systemctl is-active --quiet mariadb" SQLNodes
    - ansible -B 30 -i files/inventory.$STACKNAME --key-file ../gc_key.pem -a "systemctl is-active --quiet slurmctld" ManagementNodes
    - ansible -B 30 -i files/inventory.$STACKNAME --key-file ../gc_key.pem -a "systemctl is-active --quiet slurmdbd" ManagementNodes
    
    - bash -e ./tests/run_tests.sh all "files/inventory.$STACKNAME" "../gc_key.pem"
    - bash -e ./tests/run_tests.sh ComputeNodes "files/inventory.$STACKNAME" "../gc_key.pem"
    - bash -e ./tests/run_tests.sh LoginNodes "files/inventory.$STACKNAME" "../gc_key.pem"
    - bash -e ./tests/run_tests.sh ManagementNodes "files/inventory.$STACKNAME" "../gc_key.pem"
    - bash -e ./tests/run_tests.sh NFSNodes "files/inventory.$STACKNAME" "../gc_key.pem"
    - bash -e ./tests/run_tests.sh SQLNodes "files/inventory.$STACKNAME" "../gc_key.pem"
    
    # licensing https://gitlab.erc.monash.edu.au/hpc-team/license_server/tree/master/roles/avizo_license_monitor

manual_cluster_spawn:
  stage: push_button_spawn_cluster
  tags:
  - heat
  - ansible
  before_script:
    - echo "press button spawn cluster."
    - echo "for this to work you have to provide a variable called manual stackname"
    - echo I still need to handle os password
    - echo $MANUAL_STACKNAME
    - echo "$GC_KEY" > gc_key.pem
    - chmod 400 gc_key.pem
    - echo "$HPCCICD_openrc" > ./$NECTAR_ALLOCATION-openrc.sh
  script:
    - source ./$NECTAR_ALLOCATION-openrc.sh
    - bash -x ./CICD/heat/heatcicdwrapper.sh create $MANUAL_STACKNAME
    - openstack stack list
    - export STACKNAME=$MANUAL_STACKNAME
    - sleep 25
    - bash -x CICD/ansible_create_cluster_script.sh
  when: manual 
  only:
    refs:
      - "cicd"

extended:
  stage: extended
  tags:
  - heat
  - ansible
  before_script:
    - echo "cleanup stack"
    - sleep 30
    - echo "$HPCCICD_openrc" > ./$NECTAR_ALLOCATION-openrc.sh
  script:
    - source ./$NECTAR_ALLOCATION-openrc.sh
    - bash -x ./CICD/heat/heatcicdwrapper.sh delete_if_exists $STACKNAME
  only:
    variables:
      - $EXTENDED != null
  
clean:
  stage: clean
  tags:
  - heat
  before_script:
    - echo "cleanup stack"
    - sleep 30
    - echo "$HPCCICD_openrc" > ./$NECTAR_ALLOCATION-openrc.sh
  script:
    - source ./$NECTAR_ALLOCATION-openrc.sh
    - bash -x ./CICD/heat/heatcicdwrapper.sh delete_if_exists $STACKNAME
  when: manual